-------------------------- MODULE ProofCorrectness --------------------------

EXTENDS ProofInvariants


THEOREM init_CorrectnessInvariants ==
  Init => 
    /\ CorrectnessInvariants
    /\ StableNetwork
<1> SUFFICES ASSUME Init,
                    TypeInvariant,
                    StableNetwork
             PROVE CorrectnessInvariants
  BY Zenon, init_TypeInvariant, init_StableNetwork
<1>P1. 
  /\ LeafSetsAreBalanced 
  /\ LeafSetsAreProper 
  /\ LeafSetsAreOrganized 
  /\ MessageLeafSetInvariants 
  /\ LeafSetNodesAreParticipating
  /\ MessageNodesAreParticipating 
  /\ ProbingSetIsParticipating 
  /\ JoinRequestingNodesAreNotParticipating 
  /\ NewNodesAreProbedByOtherNewNodes 
  /\ NeighborToJoinRight 
  /\ NeighborToJoinLeft 
  /\ JoinAndProbeRepliesConnection 
  /\ ToJoinNodeAndProbeReplyConnectionRight 
  /\ ToJoinNodeAndProbeReplyConnectionLeft 
  /\ ToJoinNodeAndLeafSetConnectionRight 
  /\ ToJoinNodeAndLeafSetConnectionLeft 
  /\ ReadyOKNodeAndRightToJoinConnection 
  BY SMT,
  init_LeafSetInvariants,
  init_MessageLeafSetInvariants, 
  init_LeafSetNodesAreParticipating,
  init_StableNetwork,
  init_MessageNodesAreParticipating, 
  init_ProbingSetIsParticipating,
  init_JoinRequestingNodesAreNotParticipating, 
  init_NewNodesAreProbedByOtherNewNodes, 
  init_NeighborToJoinRight,
  init_NeighborToJoinLeft,
  init_JoinAndProbeRepliesConnection, 
  init_ToJoinNodeAndProbeReplyConnectionRight, 
  init_ToJoinNodeAndProbeReplyConnectionLeft, 
  init_ToJoinNodeAndLeafSetConnectionRight, 
  init_ToJoinNodeAndLeafSetConnectionLeft, 
  init_ReadyOKNodeAndRightToJoinConnection
<1>P2. 
  /\ ReadyOKNodeAndLeftToJoinConnection 
  /\ RightToJoinIsProbingOrInJoinReply 
  /\ LeftToJoinIsProbingOrInJoinReply 
  /\ ClosestRightReadyOKNodeIsInLSOrProbeSet 
  /\ ClosestLeftReadyOKNodeIsInLSOrProbeSet 
  /\ ProbingOrKnownToClosestRightReadyOKNode 
  /\ ProbingOrKnownToClosestLeftReadyOKNode 
  /\ JoinReplyHasClosestRightNode_1 
  /\ JoinReplyHasClosestLeftNode_1 
  /\ JoinReplyHasClosestRightNode_2 
  /\ JoinReplyHasClosestLeftNode_2 
  /\ JoinReplyHasClosestRightNode_3 
  /\ JoinReplyHasClosestLeftNode_3 
  /\ ProbeDestinationIsInProbeSet 
  /\ ProbeReplyIsFromNodeInProbeSet 
  /\ JoinRequestingNodeHasEmptyLS 
  /\ JoinReplyDestinationHasEmptyLS 
  /\ ProbingNodeHasNonEmptyLS 
  /\ ProbeReplySourceHasNonEmptyLS 
  /\ ProbeReplyDestinationHasNonEmptyLS 
  /\ DeadNodeHasEmptyLS 
  /\ DeadNodeHasEmptyProbeSet 
  /\ JoinRequestingNodeHasEmptyProbeSet 
  /\ JoinReplyDestinationHasEmptyProbeSet 
  /\ JoinReplyDestinationsDoNotProbe 
  /\ JoinReplyDestinationsDoNotGetProbeReplies 
  BY SMT,
  init_ReadyOKNodeAndLeftToJoinConnection, 
  init_RightToJoinIsProbingOrInJoinReply, 
  init_LeftToJoinIsProbingOrInJoinReply, 
  init_ClosestRightReadyOKNodeIsInLSOrProbeSet, 
  init_ClosestLeftReadyOKNodeIsInLSOrProbeSet, 
  init_ProbingOrKnownToClosestRightReadyOKNode, 
  init_ProbingOrKnownToClosestLeftReadyOKNode, 
  init_JoinReplyHasClosestRightNode_1, 
  init_JoinReplyHasClosestLeftNode_1, 
  init_JoinReplyHasClosestRightNode_2, 
  init_JoinReplyHasClosestLeftNode_2, 
  init_JoinReplyHasClosestRightNode_3, 
  init_JoinReplyHasClosestLeftNode_3, 
  init_ProbeDestinationIsInProbeSet, 
  init_ProbeReplyIsFromNodeInProbeSet, 
  init_JoinRequestingNodeHasEmptyLS, 
  init_JoinReplyDestinationHasEmptyLS, 
  init_ProbingNodeHasNonEmptyLS, 
  init_ProbeReplySourceHasNonEmptyLS, 
  init_ProbeReplyDestinationHasNonEmptyLS, 
  init_DeadNodeHasEmptyLS,
  init_DeadNodeHasEmptyProbeSet, 
  init_JoinRequestingNodeHasEmptyProbeSet, 
  init_JoinReplyDestinationHasEmptyProbeSet, 
  init_JoinReplyDestinationsDoNotProbe, 
  init_JoinReplyDestinationsDoNotGetProbeReplies
<1>P3.
  /\ NodeIsNotInItsJoinReply
  /\ ResponsibleNodeIsClosestOnOneSide 
  /\ SameMessageNode 
  /\ NoSameToJoinNode 
  /\ ToJoinNodeIsReadyOKOrInLeafSet 
  /\ NoFailedNodes 
  /\ NoMessageFailedNodes 
  /\ NoMessagesFromDeadNodes 
  /\ NoJoinRepliesToDeadNodes  
  /\ DeadNodesAreNotToJoin 
  /\ OnlyReadyNodesHaveToJoinNodes
  /\ OwnToJoinNodeIsNotCovered 
  /\ ToJoinNodesAreClose
  /\ JoinRequestingNodesAreWaiting 
  /\ LeaseNodesAreReadyOrOK 
  /\ LeaseDestinationIsReadyOrOK 
  BY SMT,
  init_NodeIsNotInItsJoinReply,
  init_ResponsibleNodeIsClosestOnOneSide, 
  init_SameMessageNode, 
  init_NoSameToJoinNode, 
  init_ToJoinNodeIsReadyOKOrInLeafSet, 
  init_NoFailedNodes, 
  init_NoMessageFailedNodes, 
  init_NoMessagesFromDeadNodes, 
  init_NoJoinRepliesToDeadNodes,  
  init_DeadNodesAreNotToJoin, 
  init_OnlyReadyNodesHaveToJoinNodes, 
  init_OwnToJoinNodeIsNotCovered, 
  init_ToJoinNodesAreClose, 
  init_JoinRequestingNodesAreWaiting, 
  init_LeaseNodesAreReadyOrOK, 
  init_LeaseDestinationIsReadyOrOK
<1>P4.
  /\ NodeDoesNotMessageItself 
  /\ JoinReplyProperties 
  /\ AtMostOneJoinRequest 
  /\ AtMostOneJoinReply 
  /\ AtMostOneProbe 
  /\ AtMostOneProbeReply 
  /\ SeparateJoinRequestsAndReplies 
  /\ SeparateProbesAndProbeReplies 
  /\ ThereAreNodes 
  /\ ProbeReplySourceKnowsDestination 
  BY SMT,
  init_NodeDoesNotMessageItself, 
  init_JoinReplyProperties, 
  init_AtMostOneJoinRequest, 
  init_AtMostOneJoinReply, 
  init_AtMostOneProbe, 
  init_AtMostOneProbeReply, 
  init_SeparateJoinRequestsAndReplies, 
  init_SeparateProbesAndProbeReplies, 
  init_ThereAreNodes,
  init_ProbeReplySourceKnowsDestination
<1>P5. /\ ToJoinNodeIsDifferentFromResponsibleNode
       /\ ProbeReplySourceKnowsDestination_1
       /\ ResponsibleNodeIsKnown
       /\ LeftToJoinNodeFarOrInProbeReply
       /\ RightToJoinNodeFarOrInProbeReply
       /\ RightToJoinNodeIsNotCovered
       /\ LeftToJoinNodeIsNotCovered
  BY SMT,
      init_ToJoinNodeIsDifferentFromResponsibleNode,
      init_ProbeReplySourceKnowsDestination_1,
      init_ResponsibleNodeIsKnown,
      init_LeftToJoinNodeFarOrInProbeReply,
      init_RightToJoinNodeFarOrInProbeReply,
      init_RightToJoinNodeIsNotCovered,
      init_LeftToJoinNodeIsNotCovered
<1>1. SUFFICES ASSUME TRUE 
               PROVE /\ ExclusiveCoverage
                     /\ LeafSetContentIsNonDead
                     /\ ToJoinNodesAreNotCovered
  BY SMT, <1>P1, <1>P2, <1>P3, <1>P4, <1>P5 DEF CorrectnessInvariants
<1>2. ExclusiveCoverage
  BY SMT, StableNetwork_ExclusiveCoverage, type_ReadyNodes, <1>P1, <1>P2, <1>P3, <1>P4, type_ReadyNodes 
    DEF StableNetwork, ExclusiveCoverage, TypeInvariant, LeafSetsAreBalanced, LeafSetsAreProper,
        LeafSetsAreOrganized
<1>3. LeafSetContentIsNonDead
  BY SMT, <1>P1, <1>P2, <1>P3, <1>P4, def_LeafSetContentIsNonDead
<1>4. ToJoinNodesAreNotCovered
  BY SMT, <1>P1, <1>P2, <1>P3, <1>P4, init_ToJoinNodesAreNotCovered
<1> QED BY SMT, <1>2, <1>3, <1>4

THEOREM next_CorrectnessInvariants ==
  ASSUME TypeInvariant,
         CorrectnessInvariants,
         StableNetwork,
         [Next]_vars
  PROVE CorrectnessInvariants'
<1> SUFFICES ASSUME TypeInvariant',
                    StableNetwork'
             PROVE CorrectnessInvariants'
  BY Zenon, next_TypeInvariant, next_StableNetwork
<1>P1. 
  /\ LeafSetsAreBalanced'
  /\ LeafSetsAreProper'
  /\ LeafSetsAreOrganized'
  /\ MessageLeafSetInvariants'
  /\ LeafSetNodesAreParticipating'
  /\ MessageNodesAreParticipating'
  /\ ProbingSetIsParticipating'
  /\ JoinRequestingNodesAreNotParticipating'
  /\ NewNodesAreProbedByOtherNewNodes'
  /\ NeighborToJoinRight'
  /\ NeighborToJoinLeft'
  /\ JoinAndProbeRepliesConnection' 
  /\ ToJoinNodeAndProbeReplyConnectionRight'
  /\ ToJoinNodeAndProbeReplyConnectionLeft'
  /\ ToJoinNodeAndLeafSetConnectionRight'
  /\ ToJoinNodeAndLeafSetConnectionLeft'
  /\ ReadyOKNodeAndRightToJoinConnection'
  BY Zenon,
  next_LeafSetInvariants,
  next_MessageLeafSetInvariants, 
  next_LeafSetNodesAreParticipating,
  next_StableNetwork,
  next_MessageNodesAreParticipating, 
  next_ProbingSetIsParticipating,
  next_JoinRequestingNodesAreNotParticipating, 
  next_NewNodesAreProbedByOtherNewNodes, 
  next_NeighborToJoinRight,
  next_NeighborToJoinLeft,
  next_JoinAndProbeRepliesConnection, 
  next_ToJoinNodeAndProbeReplyConnectionRight, 
  next_ToJoinNodeAndProbeReplyConnectionLeft, 
  next_ToJoinNodeAndLeafSetConnectionRight, 
  next_ToJoinNodeAndLeafSetConnectionLeft, 
  next_ReadyOKNodeAndRightToJoinConnection
<1>P2. 
  /\ ReadyOKNodeAndLeftToJoinConnection'
  /\ RightToJoinIsProbingOrInJoinReply'
  /\ LeftToJoinIsProbingOrInJoinReply'
  /\ ClosestRightReadyOKNodeIsInLSOrProbeSet'
  /\ ClosestLeftReadyOKNodeIsInLSOrProbeSet'
  /\ ProbingOrKnownToClosestRightReadyOKNode'
  /\ ProbingOrKnownToClosestLeftReadyOKNode'
  /\ JoinReplyHasClosestRightNode_1'
  /\ JoinReplyHasClosestLeftNode_1'
  /\ JoinReplyHasClosestRightNode_2'
  /\ JoinReplyHasClosestLeftNode_2'
  /\ JoinReplyHasClosestRightNode_3'
  /\ JoinReplyHasClosestLeftNode_3'
  /\ ProbeDestinationIsInProbeSet'
  /\ ProbeReplyIsFromNodeInProbeSet'
  /\ JoinRequestingNodeHasEmptyLS'
  /\ JoinReplyDestinationHasEmptyLS'
  /\ ProbingNodeHasNonEmptyLS'
  /\ ProbeReplySourceHasNonEmptyLS'
  /\ ProbeReplyDestinationHasNonEmptyLS'
  /\ DeadNodeHasEmptyLS'
  /\ DeadNodeHasEmptyProbeSet'
  /\ JoinRequestingNodeHasEmptyProbeSet'
  /\ JoinReplyDestinationHasEmptyProbeSet'
  /\ JoinReplyDestinationsDoNotProbe'
  /\ JoinReplyDestinationsDoNotGetProbeReplies'
  BY SMT,
  next_ReadyOKNodeAndLeftToJoinConnection, 
  next_RightToJoinIsProbingOrInJoinReply, 
  next_LeftToJoinIsProbingOrInJoinReply, 
  next_ClosestRightReadyOKNodeIsInLSOrProbeSet, 
  next_ClosestLeftReadyOKNodeIsInLSOrProbeSet, 
  next_ProbingOrKnownToClosestRightReadyOKNode, 
  next_ProbingOrKnownToClosestLeftReadyOKNode, 
  next_JoinReplyHasClosestRightNode_1, 
  next_JoinReplyHasClosestLeftNode_1, 
  next_JoinReplyHasClosestRightNode_2, 
  next_JoinReplyHasClosestLeftNode_2, 
  next_JoinReplyHasClosestRightNode_3, 
  next_JoinReplyHasClosestLeftNode_3, 
  next_ProbeDestinationIsInProbeSet, 
  next_ProbeReplyIsFromNodeInProbeSet, 
  next_JoinRequestingNodeHasEmptyLS, 
  next_JoinReplyDestinationHasEmptyLS, 
  next_ProbingNodeHasNonEmptyLS, 
  next_ProbeReplySourceHasNonEmptyLS, 
  next_ProbeReplyDestinationHasNonEmptyLS, 
  next_DeadNodeHasEmptyLS,
  next_DeadNodeHasEmptyProbeSet, 
  next_JoinRequestingNodeHasEmptyProbeSet, 
  next_JoinReplyDestinationHasEmptyProbeSet, 
  next_JoinReplyDestinationsDoNotProbe, 
  next_JoinReplyDestinationsDoNotGetProbeReplies
<1>P3.
  /\ NodeIsNotInItsJoinReply'
  /\ ResponsibleNodeIsClosestOnOneSide' 
  /\ SameMessageNode' 
  /\ NoSameToJoinNode' 
  /\ ToJoinNodeIsReadyOKOrInLeafSet' 
  /\ NoFailedNodes'
  /\ NoMessageFailedNodes'
  /\ NoMessagesFromDeadNodes'
  /\ NoJoinRepliesToDeadNodes' 
  /\ DeadNodesAreNotToJoin'
  /\ OnlyReadyNodesHaveToJoinNodes'
  /\ OwnToJoinNodeIsNotCovered'
  /\ ToJoinNodesAreClose'
  /\ JoinRequestingNodesAreWaiting'
  /\ LeaseNodesAreReadyOrOK'
  /\ LeaseDestinationIsReadyOrOK'
  BY SMT,
  next_NodeIsNotInItsJoinReply,
  next_ResponsibleNodeIsClosestOnOneSide, 
  next_SameMessageNode, 
  next_NoSameToJoinNode, 
  next_ToJoinNodeIsReadyOKOrInLeafSet, 
  next_NoFailedNodes, 
  next_NoMessageFailedNodes, 
  next_NoMessagesFromDeadNodes, 
  next_NoJoinRepliesToDeadNodes,  
  next_DeadNodesAreNotToJoin, 
  next_OnlyReadyNodesHaveToJoinNodes, 
  next_OwnToJoinNodeIsNotCovered, 
  next_ToJoinNodesAreClose, 
  next_JoinRequestingNodesAreWaiting, 
  next_LeaseNodesAreReadyOrOK, 
  next_LeaseDestinationIsReadyOrOK
<1>P4.
  /\ NodeDoesNotMessageItself'
  /\ JoinReplyProperties'
  /\ AtMostOneJoinRequest'
  /\ AtMostOneJoinReply'
  /\ AtMostOneProbe'
  /\ AtMostOneProbeReply'
  /\ SeparateJoinRequestsAndReplies'
  /\ SeparateProbesAndProbeReplies'
  /\ ThereAreNodes'
  /\ ProbeReplySourceKnowsDestination'
  BY SMT,
  next_NodeDoesNotMessageItself, 
  next_JoinReplyProperties, 
  next_AtMostOneJoinRequest, 
  next_AtMostOneJoinReply, 
  next_AtMostOneProbe, 
  next_AtMostOneProbeReply, 
  next_SeparateJoinRequestsAndReplies, 
  next_SeparateProbesAndProbeReplies, 
  next_ThereAreNodes,
  next_ProbeReplySourceKnowsDestination
<1>P5. /\ ToJoinNodeIsDifferentFromResponsibleNode'
       /\ ProbeReplySourceKnowsDestination_1'
       /\ ResponsibleNodeIsKnown'
       /\ LeftToJoinNodeFarOrInProbeReply'
       /\ RightToJoinNodeFarOrInProbeReply'
       /\ RightToJoinNodeIsNotCovered'
       /\ LeftToJoinNodeIsNotCovered'
  BY SMT,
      next_ToJoinNodeIsDifferentFromResponsibleNode,
      next_ProbeReplySourceKnowsDestination_1,
      next_ResponsibleNodeIsKnown,
      next_LeftToJoinNodeFarOrInProbeReply,
      next_RightToJoinNodeFarOrInProbeReply,
      next_RightToJoinNodeIsNotCovered,
      next_LeftToJoinNodeIsNotCovered
<1>1. SUFFICES ASSUME TRUE 
               PROVE /\ ExclusiveCoverage'
                     /\ LeafSetContentIsNonDead'
                     /\ ToJoinNodesAreNotCovered'
  BY SMT, <1>P1, <1>P2, <1>P3, <1>P4, <1>P5 DEF CorrectnessInvariants
<1>2. ExclusiveCoverage'
  <2> SUFFICES ASSUME ReadyNodes' \in SUBSET I PROVE ExclusiveCoverage'
    BY Zenon DEF ReadyNodes
  <2> QED BY SMT, StableNetwork_ExclusiveCoverage, <1>P1, <1>P2, <1>P3, <1>P4
    DEF StableNetwork, ExclusiveCoverage, TypeInvariant, LeafSetsAreBalanced, LeafSetsAreProper,
        LeafSetsAreOrganized
<1>3. LeafSetContentIsNonDead'
  BY SMT, <1>P1, <1>P2, <1>P3, <1>P4, next_LeafSetContentIsNonDead
<1>4. ToJoinNodesAreNotCovered'
  BY SMT, <1>P1, <1>P2, <1>P3, <1>P4, next_ToJoinNodesAreNotCovered
<1> QED BY SMT, <1>2, <1>3, <1>4

(* Our type invariant is indeed an invariant of LuPastry. *)
THEOREM spec_TypeInvariant ==
  Spec => [] TypeInvariant
<1>1. TypeInvariant /\ [Next]_vars => TypeInvariant'
  BY next_TypeInvariant
<1>. QED BY init_TypeInvariant, <1>1, PTL DEF Spec

(* Our correctness invariants are indeed invariants of LuPastry. *)
THEOREM spec_CorrectnessInvariants == 
  Spec => [](CorrectnessInvariants /\ StableNetwork)
<1>1. TypeInvariant /\ CorrectnessInvariants /\ StableNetwork /\ [Next]_vars
      => (CorrectnessInvariants /\ StableNetwork)'
  BY next_CorrectnessInvariants, next_StableNetwork
<1>. QED  BY init_CorrectnessInvariants, <1>1, spec_TypeInvariant, PTL DEF Spec

(* Our main correctness theorem: CorrectDelivery is an invariant of LuPastry. *)
THEOREM LuPastryCorrectness ==
  Spec => [] CorrectDelivery
BY PTL, def_CorrectDelivery, spec_TypeInvariant, spec_CorrectnessInvariants DEF CorrectnessInvariants

=============================================================================
\* Modification History
\* Last modified Wed Feb 10 18:38:53 CET 2016 by azmy
\* Last modified Fri Nov 13 14:12:13 CET 2015 by noran
\* Created Thu Mar 12 09:15:30 CET 2015 by noran
